# All files / src Obfuscator.ts

100% Statements 35/35
100% Branches 6/6
100% Functions 4/4
100% Lines 34/34

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    1721x
    1x

    1x

    1x
    1x
    1x
    1x

    1x
    1x

    1x

    1x

    1x

    1812x
    1812x
    1812x
    1812x
    1812x

    1812x
    3x

    1809x

    1809x

    1809x

    9045x

    9045x

    1809x

    1809x
    202x

    1809x

    1809x

    1809x

    2011x

    285696x

    285696x
    96616x

     import { injectable, inject } from 'inversify';
    import { ServiceIdentifiers } from './container/ServiceIdentifiers';

    import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { TNodeTransformersFactory } from './types/container/TNodeTransformersFactory';
    import { TVisitorDirection } from './types/TVisitorDirection';

    import { ICustomNodeGroup } from './interfaces/custom-nodes/ICustomNodeGroup';
    import { IObfuscationEventEmitter } from './interfaces/event-emitters/IObfuscationEventEmitter';
    import { IObfuscator } from './interfaces/IObfuscator';
    import { IOptions } from './interfaces/options/IOptions';
    import { INodeTransformer } from './interfaces/node-transformers/INodeTransformer';
    import { IStackTraceAnalyzer } from './interfaces/stack-trace-analyzer/IStackTraceAnalyzer';
    import { IStackTraceData } from './interfaces/stack-trace-analyzer/IStackTraceData';
    import { IStorage } from './interfaces/storages/IStorage';

    import { NodeTransformers } from './enums/container/NodeTransformers';
    import { NodeType } from './enums/NodeType';
    import { ObfuscationEvents } from './enums/ObfuscationEvents';
    import { VisitorDirection } from './enums/VisitorDirection';

    import { Node } from './node/Node';
    import { NodeUtils } from './node/NodeUtils';

    @injectable()
    export class Obfuscator implements IObfuscator {
        /**
         * @type {Map<string, NodeTransformers[]>}
         */
        private static readonly nodeControlFlowTransformersMap: Map <string, NodeTransformers[]> = new Map([
            [NodeType.FunctionDeclaration, [NodeTransformers.FunctionControlFlowTransformer]],
            [NodeType.FunctionExpression, [NodeTransformers.FunctionControlFlowTransformer]]
        ]);

        /**
         * @type {Map<string, NodeTransformers[]>}
         */
        private static readonly nodeObfuscatorsMap: Map <string, NodeTransformers[]> = new Map([
            [NodeType.ArrowFunctionExpression, [NodeTransformers.FunctionObfuscator]],
            [NodeType.ClassDeclaration, [NodeTransformers.FunctionDeclarationObfuscator]],
            [NodeType.CatchClause, [NodeTransformers.CatchClauseObfuscator]],
            [NodeType.FunctionDeclaration, [
                NodeTransformers.FunctionDeclarationObfuscator,
                NodeTransformers.FunctionObfuscator
            ]],
            [NodeType.FunctionExpression, [NodeTransformers.FunctionObfuscator]],
            [NodeType.MemberExpression, [NodeTransformers.MemberExpressionObfuscator]],
            [NodeType.MethodDefinition, [NodeTransformers.MethodDefinitionObfuscator]],
            [NodeType.ObjectExpression, [NodeTransformers.ObjectExpressionObfuscator]],
            [NodeType.VariableDeclaration, [NodeTransformers.VariableDeclarationObfuscator]],
            [NodeType.LabeledStatement, [NodeTransformers.LabeledStatementObfuscator]],
            [NodeType.Literal, [NodeTransformers.LiteralObfuscator]]
        ]);

        /**
         * @type {IStorage<ICustomNodeGroup>}
         */
        private readonly customNodeGroupStorage: IStorage<ICustomNodeGroup>;

        /**
         * @type {TNodeTransformersFactory}
         */
        private readonly nodeTransformersFactory: TNodeTransformersFactory;

        /**
         * @type {IObfuscationEventEmitter}
         */
        private readonly obfuscationEventEmitter: IObfuscationEventEmitter;

        /**
         * @type {IOptions}
         */
        private readonly options: IOptions;

        /**
         * @type {IStackTraceAnalyzer}
         */
        private readonly stackTraceAnalyzer: IStackTraceAnalyzer;

        /**
         * @param stackTraceAnalyzer
         * @param obfuscationEventEmitter
         * @param customNodeGroupStorage
         * @param nodeTransformersFactory
         * @param options
         */
        constructor (
            @inject(ServiceIdentifiers.IStackTraceAnalyzer) stackTraceAnalyzer: IStackTraceAnalyzer,
            @inject(ServiceIdentifiers.IObfuscationEventEmitter) obfuscationEventEmitter: IObfuscationEventEmitter,
            @inject(ServiceIdentifiers['IStorage<ICustomNodeGroup>']) customNodeGroupStorage: IStorage<ICustomNodeGroup>,
            @inject(ServiceIdentifiers['Factory<INodeTransformer[]>']) nodeTransformersFactory: TNodeTransformersFactory,
            @inject(ServiceIdentifiers.IOptions) options: IOptions
        ) {
            this.stackTraceAnalyzer = stackTraceAnalyzer;
            this.obfuscationEventEmitter = obfuscationEventEmitter;
            this.customNodeGroupStorage = customNodeGroupStorage;
            this.nodeTransformersFactory = nodeTransformersFactory;
            this.options = options;
        }

        /**
         * @param astTree
         * @returns {ESTree.Program}
         */
        public obfuscateAstTree (astTree: ESTree.Program): ESTree.Program {
            if (Node.isProgramNode(astTree) && !astTree.body.length) {
                return astTree;
            }

            NodeUtils.parentize(astTree);

            const stackTraceData: IStackTraceData[] = this.stackTraceAnalyzer.analyze(astTree.body);

            // initialize custom node groups and configure custom nodes
            this.customNodeGroupStorage
                .getStorage()
                .forEach((customNodeGroup: ICustomNodeGroup) => {
                    customNodeGroup.initialize();

                    this.obfuscationEventEmitter.once(
                        customNodeGroup.getAppendEvent(),
                        customNodeGroup.appendCustomNodes.bind(customNodeGroup)
                    );
                });

            this.obfuscationEventEmitter.emit(ObfuscationEvents.BeforeObfuscation, astTree, stackTraceData);

            // first pass: control flow flattening
            if (this.options.controlFlowFlattening) {
                this.transformAstTree(
                    astTree,
                    VisitorDirection.leave,
                    this.nodeTransformersFactory(Obfuscator.nodeControlFlowTransformersMap)
                );
            }

            // second pass: nodes obfuscation
            this.transformAstTree(
                astTree,
                VisitorDirection.enter,
                this.nodeTransformersFactory(Obfuscator.nodeObfuscatorsMap)
            );

            this.obfuscationEventEmitter.emit(ObfuscationEvents.AfterObfuscation, astTree, stackTraceData);

            return astTree;
        }

        /**
         * @param astTree
         * @param direction
         * @param nodeTransformersConcreteFactory
         */
        private transformAstTree (
            astTree: ESTree.Program,
            direction: TVisitorDirection,
            nodeTransformersConcreteFactory: (nodeType: string) => INodeTransformer[]
        ): void {
            estraverse.traverse(astTree, {
                [direction]: (node: ESTree.Node, parentNode: ESTree.Node): void => {
                    const nodeTransformers: INodeTransformer[] = nodeTransformersConcreteFactory(node.type);

                    nodeTransformers.forEach((nodeTransformer: INodeTransformer) => {
                        nodeTransformer.transformNode(node, parentNode);
                    });
                }
            });
        }
    }